// Code generated by go-swagger; DO NOT EDIT.

package networks

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// VMNetworkListHandlerFunc turns a function with the right signature into a vm network list handler
type VMNetworkListHandlerFunc func(VMNetworkListParams) middleware.Responder

// Handle executing the request and returning a response
func (fn VMNetworkListHandlerFunc) Handle(params VMNetworkListParams) middleware.Responder {
	return fn(params)
}

// VMNetworkListHandler interface for that can handle valid vm network list params
type VMNetworkListHandler interface {
	Handle(VMNetworkListParams) middleware.Responder
}

// NewVMNetworkList creates a new http.Handler for the vm network list operation
func NewVMNetworkList(ctx *middleware.Context, handler VMNetworkListHandler) *VMNetworkList {
	return &VMNetworkList{Context: ctx, Handler: handler}
}

/*VMNetworkList swagger:route GET /api/networks Networks vmNetworkList

Get network list

*/
type VMNetworkList struct {
	Context *middleware.Context
	Handler VMNetworkListHandler
}

func (o *VMNetworkList) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewVMNetworkListParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
